package com.jpattern.orm.datasource;

import com.jpattern.orm.IOrmClassToolMap;
import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.session.ASession;
import com.jpattern.orm.session.ISqlPerformer;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.transaction.ITransactionDefinition;

/**
 * 
 * @author Francesco Cina
 *
 * 21/mag/2011
 */
public class DataSourceSession extends ASession {

	private final DataSourceSessionProvider dataSourceSessionProvider;

	public DataSourceSession(DataSourceSessionProvider dataSourceSessionProvider, IOrmClassToolMap ormClassToolMap) {
		super(ormClassToolMap);
		this.dataSourceSessionProvider = dataSourceSessionProvider;
	}

	@Override
	public ITransaction getTransaction(ITransactionDefinition transactionDefinition) throws OrmException {
		return new DataSourceTransaction(dataSourceSessionProvider, transactionDefinition);
	}
	
	@Override
	public ISqlPerformer sqlPerformer() throws OrmException {
		return new DataSourceSqlPerformer(dataSourceSessionProvider);
	}

}
